/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 27/03/2018
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.KelompokTransaksiDetail;
import com.portofolio.entity.vo.KelompokTransaksiDetailId;

@Lazy
@Repository
public interface KelompokTransaksiDetailMasterDao extends CrudRepository<KelompokTransaksiDetail, KelompokTransaksiDetailId> {

	@Query(QListAlls + " where model.id.kdKelompokTransaksi = :kdKelompokTransaksi and model.id.kdProfile=:kdProfile ")
	List<Map<String, Object>> findByKode(@Param("kdKelompokTransaksi") Integer kdKelompokTransaksi,
			@Param("kdProfile") Integer kdProfile);

	String QListAlls = "select new map(model.id.kdKelompokTransaksi as kdKelompokTransaksi"
			+ ", model.id.kdProfile as kdProfile, model.qtyHariMinPostingBefore as qtyHariMinPostingBefore"
			+ ", model.kdStrukturNomor as kdStrukturNomor " + ", model.qtyJamMaxPostingBefore as qtyJamMaxPostingBefore"
			+ ", model.qtyHariActiveAfterSK as qtyHariActiveAfterSK"
			+ ", model.qtyHariMinNewPosting as qtyHariMinNewPosting"
			+ ", model.qtyHariMaxPostingExpired as qtyHariMaxPostingExpired, model.isRealSK as isRealSK"
			+ ", model.qtyJamMaxPostingExpired as qtyJamMaxPostingExpired"
			+ ", model.statusEnabled as statusEnabled, model.noRec as noRec, model.version as version "
			+ ", kelompokTransaksi.namaKelompokTransaksi as namaKelompokTransaksi"
			+ ", model.isCostInOut as isCostInOut, strukturNomor.namaStrukturNomor as namaStrukturNomor) from KelompokTransaksiDetail model "
			+ " left join model.kelompokTransaksi kelompokTransaksi"
			+ " left join model.strukturNomor strukturNomor ";

	@Query(QListAlls
			+ " where model.id.kdProfile=:kdProfile and kelompokTransaksi.namaKelompokTransaksi like %:namakelompoktransaksi%")
	Page<Map<String, Object>> findAllList(@Param("namakelompoktransaksi") String namakelompoktransaksi,
			Pageable pageReq, @Param("kdProfile") Integer kdProfile);

	KelompokTransaksiDetail findOneByIdKdKelompokTransaksiAndIdKdProfile(Integer kdKelompokTransaksi,
			Integer kdProfile);

}
